poj 2528 Mayor's posters(线段树区间覆盖、离散化)

Mayor‘s posters

Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 49385   Accepted: 14304

Description

The citizens of Bytetown, AB, could not stand that the candidates in the mayoral election campaign have been placing their electoral posters at all places at their whim. The city council has finally decided to build an electoral
wall for placing the posters and introduce the following rules:

  • Every candidate can place exactly one poster on the wall.
  • All posters are of the same height equal to the height of the wall; the width of a poster can be any integer number of bytes (byte is the unit of length in Bytetown).
  • The wall is divided into segments and the width of each segment is one byte.
  • Each poster must completely cover a contiguous number of wall segments.

They have built a wall 10000000 bytes long (such that there is enough place for all candidates). When the electoral campaign was restarted, the candidates were placing their posters on the wall and their posters differed widely in width. Moreover, the candidates
started placing their posters on wall segments already occupied by other posters. Everyone in Bytetown was curious whose posters will be visible (entirely or in part) on the last day before elections.

Your task is to find the number of visible posters when all the posters are placed given the information about posters‘ size, their place and order of placement on the electoral wall.

Input

The first line of input contains a number c giving the number of cases that follow. The first line of data for a single case contains number 1 <= n <= 10000. The subsequent n lines describe the posters in the order in which they
were placed. The i-th line among the n lines contains two integer numbers li and ri which are the number of the wall segment occupied by the left end and the right end of the i-th poster, respectively. We know that for each 1 <= i <= n, 1 <= li
<= ri <= 10000000. After the i-th poster is placed, it entirely covers all wall segments numbered li, li+1 ,... , ri.

Output

For each input data set print the number of visible posters after all the posters are placed.

The picture below illustrates the case of the sample input.

Sample Input

1
5
1 4
2 6
8 10
3 4
7 10

Sample Output

4

Source

Alberta Collegiate Programming Contest 2003.10.18

题目大意:在一面墙上贴海报,每张海报一定贴满一整张瓷砖(如上图)。问有几张海报能够被看到(露出一部分也算)。

分析:既然是区间上的问题,一定用线段树来求解。所以容易想到,以瓷砖作为区间,海报贴住瓷砖的范围就对区间进行覆盖。

问题抽象出来就是:在一面墙上染色,最后问有几种不同的颜色。

问题到这里已经差不多解决了。但是一看数据范围,瓷砖有10000000张,如果建树的话,肯定MLE了。这里就用到了离散化。

---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

离散化:通俗点说,离散化就是压缩区间,使原有的长区间映射到新的短区间,但是区间压缩前后的覆盖关系不变。举个例子:

有一条1到10的数轴(长度为9),给定4个区间[2,4] [3,6] [8,10] [6,9],覆盖关系就是后者覆盖前者,每个区间染色依次为 1 2 3 4。

现在我们抽取这4个区间的8个端点,2 4 3 6 8 10 6 9

然后删除相同的端点,这里相同的端点为6,则剩下2 4 3 6 8 10 9

对其升序排序,得2 3 4 6 8 9 10

然后建立映射

2     3     4     6     8     9   10

↓     ↓      ↓     ↓     ↓     ↓     ↓

1     2     3     4     5     6     7

那么新的4个区间为 [1,3] [2,4] [5,7] [4,6],覆盖关系没有被改变。新数轴为1到7,即原数轴的长度从9压缩到6,显然构造[1,7]的线段树比构造[1,10]的线段树更省空间,搜索也更快,但是求解的结果却是一致的。(以上我是复制别人的= = ,自己也是第一次接触离散化,只是觉得他讲的很通俗。)

---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

再回到这题,其实跟普通的离散化又是不一样的。原因看题目中的图:他一张瓷砖代表了一个区间,而不是一个点,这是离散化时需要处理的。

为什么如果代表一个区间的时候,就不能进行普通的离散化呢?

例如:对于区间【1,4】和【5,10】,如上图,【1,10】倍全部覆盖,如果对上述区间离散化,会得到【1,2】和【3,4】两个区间,可以认为【1,4】全部被覆盖。

在看【1,4】,【6,10】,离散化结果和【1,4】【5,10】一样,但实际上,【1,10】并没有被完全覆盖。

如何解决?对区间进行排序后遍历,如果相邻的两个数相差大于1,就随意加一个大小处在两个之中的数字。这样就很好的解决了上面的问题。

#include<stdio.h>
#include<string.h>
#include<iostream>
#include<algorithm>
#define M 10050
using namespace std;
struct post{
	int l,r;
}post[M];
int x[M<<1],ans,a[M<<4];
int tohash[10000005];
struct tree{
	int l,r,color;
}tree[1000005];
void build(int l,int r,int root)
{
	tree[root].l=l;
	tree[root].r=r;
	tree[root].color=-1;   //初始化赋为-1
	if(l==r)return ;
	int mid=l+r>>1;
	build(l,mid,root<<1);
	build(mid+1,r,root<<1|1);
}
void pushdown(int root){     //如果一个区间里面的颜色有多种,就认为color是-1
	if(tree[root].color!=-1)
		{tree[root<<1].color=tree[root<<1|1].color=tree[root].color;
			tree[root].color=-1;
	}
  return;
}
void update(int l,int r,int z,int root)
{
	if(l==tree[root].l&&tree[root].r==r){
		tree[root].color=z;
		return ;
	}
	pushdown(root);
	int mid=tree[root].l+tree[root].r>>1;
	if(r<=mid)update(l,r,z,root<<1);
	else if(l>mid)update(l,r,z,root<<1|1);
	else {
		update(l,mid,z,root<<1);
		update(mid+1,r,z,root<<1|1);
	}
}
void query(int root)
{
	int flag,j;
	if(tree[root].color!=-1){    //如果当前区间不是多种颜色,就直接添加入数组。
	a[ans++]=tree[root].color;
		return;
	}
	if(tree[root].l==tree[root].r)return;
	query(root<<1);
	query(root<<1|1);
	return;
}
int main()
{
  int T,i,j,k,n;
  scanf("%d",&T);
  while(T--)
  {
  	scanf("%d",&n);
  	j=0;
  	for(i=0;i<n;i++)
  	{
	  scanf("%d%d",&post[i].l,&post[i].r);
  	 x[j++]=post[i].l;
  	 x[j++]=post[i].r;
  	}
  	sort(x,x+j);
  	j=unique(x,x+j)-x;     //unique函数用于选出重复的数并放到数组最后,并返回不重复数列的末尾位置。(相当于将重复的数去掉了)
  	for(i=j-1;i>=0;i--)
  	if(x[i]!=x[i-1]+1)x[j++]=x[i-1]+1;   //解决普通离散化的缺陷
  	sort(x,x+j);
  	int num=1;
  	for(i=0;i<j;i++)
    tohash[x[i]]=num++;     //离散化映射

    build(1,num-1,1);
    for(i=0;i<n;i++)
    {
    	update(tohash[post[i].l],tohash[post[i].r],i+1,1);

    }
    memset(a,0,sizeof(a));
    ans=0;
    query(1);
    sort(a,a+ans);

    int y=1;

 for(i=1;i<ans;i++)
 if(a[i]!=a[i-1])y++;   //这里将先前可能有重复的颜色去掉,只选不重复的颜色。
    printf("%d\n",y);
  }
  return 0;
}

版权声明:本文为博主原创文章,未经博主允许不得转载。

poj 2528 Mayor's posters(线段树区间覆盖、离散化)

时间: 2024-07-31 10:46:38

poj 2528 Mayor's posters(线段树区间覆盖、离散化)的相关文章

POJ 2528 Mayor&#39;s posters (线段树区间更新+离散化)

题目链接:http://poj.org/problem?id=2528 给你n块木板,每块木板有起始和终点,按顺序放置,问最终能看到几块木板. 很明显的线段树区间更新问题,每次放置木板就更新区间里的值.由于l和r范围比较大,内存就不够了,所以就用离散化的技巧 比如将1 4化为1 2,范围缩小,但是不影响答案. 写了这题之后对区间更新的理解有点加深了,重点在覆盖的理解(更新左右两个孩子节点,然后值清空),还是要多做做题目. 1 #include <iostream> 2 #include <

poj 2528 Mayor&#39;s posters 线段树区间更新

Mayor's posters Time Limit: 1 Sec  Memory Limit: 256 MB 题目连接 http://poj.org/problem?id=2528 Description The citizens of Bytetown, AB, could not stand that the candidates in the mayoral election campaign have been placing their electoral posters at al

POJ 2528 Mayor&#39;s posters(线段树,区间覆盖,单点查询)

Mayor's posters Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 45703   Accepted: 13239 Description The citizens of Bytetown, AB, could not stand that the candidates in the mayoral election campaign have been placing their electoral post

Poj 2528 Mayor&#39;s posters (线段树+离散化)

题目连接: http://poj.org/problem?id=2528 题目大意: 有10000000块瓷砖,n张海报需要贴在墙上,每张海报所占的宽度和瓷砖宽度一样,长度是瓷砖长度的整数倍,问按照所给海报顺序向瓷砖上贴海报,最后有几张海报是可见的? 解题思路: 因为瓷砖块数和海报张数多,首选线段树,如果按照常规的建树方式,把瓷砖当做数的节点,肯定会MTL......... 所以我们可以用海报的起点和终点当做树的节点,这样树的节点才有20000个,但是这样建树的话,求海报覆盖了那些节点会很复杂,

poj 2528 Mayor&#39;s posters(线段树)

题目链接:http://poj.org/problem?id=2528 思路分析:线段树处理区间覆盖问题,也可以看做每次给一段区间染不同的颜色,最后求在整段区间上含有的所有颜色种类数: 注意由于区间太大,所以需要离散化: 区间更新:对于线段树的每个结点,标记颜色,初始时没有颜色,标记为0:当更新时,使用延迟标记,需要标记传递到子节点: 区间查询:使用深度优先查询线段树,当某个子节点的颜色不为0时,即停止深度优先搜索,并在map中查询是否已经记录该段区间的颜色: 代码如下: #include <i

POJ 2528 Mayor&#39;s posters 线段树成段更新+离散化

题目来源:POJ 2528 Mayor's posters 题意:很多张海报贴在墙上 求可以看到几张海报 看那两张图就行了 第一张俯视图 思路:最多2W个不同的数 离散化一下 然后成段更新 a[rt] = i代表这个区间是第i张报纸 更新玩之后一次query cover[i]=1代表可以看到第i张报纸 #include <cstdio> #include <algorithm> #include <cstring> using namespace std; const

Mayor&#39;s posters 线段树区间覆盖

题目链接 http://poj.org/problem?id=2528 Description The citizens of Bytetown, AB, could not stand that the candidates in the mayoral election campaign have been placing their electoral posters at all places at their whim. The city council has finally dec

poj-----(2528)Mayor&#39;s posters(线段树区间更新及区间统计+离散化)

Mayor's posters Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 43507   Accepted: 12693 Description The citizens of Bytetown, AB, could not stand that the candidates in the mayoral election campaign have been placing their electoral post

POJ 2528——Mayor&#39;s posters——————【线段树区间替换、找存在的不同区间】

Mayor's posters Time Limit:1000MS     Memory Limit:65536KB     64bit IO Format:%I64d & %I64u Submit Status Practice POJ 2528 Description The citizens of Bytetown, AB, could not stand that the candidates in the mayoral election campaign have been plac

POJ 2528 Mayor&#39;s posters(线段树区间染色+离散化或倒序更新)

Mayor's posters Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 59239   Accepted: 17157 Description The citizens of Bytetown, AB, could not stand that the candidates in the mayoral election campaign have been placing their electoral post